package me.goosemonkey.NoSpawnEggsV2;

import java.util.Arrays;

import me.goosemonkey.NoSpawnEggsV2.NoSpawnEggs.PluginVersion;

import org.bukkit.plugin.java.JavaPlugin;

public class ConfigMain extends ConfigAbstract
{
	public ConfigMain(JavaPlugin inst)
	{
		super(inst);
	}

	@Override
	public String getHeader()
	{
		return "";
	}

	@Override
	public void setDefaultValues()
	{
		this.checkSet("configVersion", 2, PluginVersion.LIGHT);
		
		
		this.checkSet("blocking.spawnEggs.enable", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.onlyBlockCreative", false, PluginVersion.LIGHT);
		
		this.checkSet("blocking.spawnEggs.$global.animal", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.monster", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.npc", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.unknown", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.spawnEggs.ExampleWorld.animal", false, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.npc", false, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);

		
		this.checkSet("blocking.golem.enable", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.golem.snow.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.golem.snow.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		
		this.checkSet("blocking.golem.iron.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.golem.iron.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		
		
		this.checkSet("blocking.chickenEgg.enable", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.chickenEgg.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.chickenEgg.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		this.checkSet("blocking.chickenEgg.sendMessage", true, PluginVersion.MODERATE);
		
		
		this.checkSet("blocking.expBottle.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.expBottle.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.expBottle.onlyBlockCreative", false, PluginVersion.FULL);
		
		this.checkSet("blocking.enderEye.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.enderEye.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.enderEye.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.enderPearl.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.enderPearl.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.enderPearl.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.boat.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.boat.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.boat.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.minecart.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.minecart.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.minecart.onlyBlockCreative", false, PluginVersion.FULL);
		
		
		this.checkSet("blocking.dispense.spawnEggs.enable", true, PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.spawnEggs.$global.animal", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.monster", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.npc", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.unknown", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.animal", false, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.npc", false, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.chickenEgg.enable", true, PluginVersion.MODERATE);
		this.checkSet("blocking.dispense.chickenEgg.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		this.checkSet("blocking.dispense.chickenEgg.dispenseSnowball", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.dispense.expBottle.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.dispense.expBottle.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		
		this.checkSet("blocking.dispense.fireCharge.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.dispense.fireCharge.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
	}

	@Override
	public String getName()
	{
		return "Config";
	}
}
