package me.goosemonkey.NoSpawnEggsV2;

import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;

public class ListenerPlayerGolem implements Listener
{
	@EventHandler
	public void onBlockPlace(BlockPlaceEvent event)
	{
		if (event.getBlock().getType() != Material.PUMPKIN && event.getBlock().getType() != Material.JACK_O_LANTERN)
			return;
		
		GolemType type = ListenerPlayerGolem.placeCreatesGolem(event);
		
		if (type == GolemType.NONE)
			return;
		
		if (NoSpawnEggs.hasPermission(event.getPlayer(), "nse.golem." + type.name().toLowerCase() + "." + event.getPlayer().getGameMode().name().toLowerCase()))
			return;
		
		if (NoSpawnEggs.getMainConfig().getBoolean("blocking.golem." + type.name().toLowerCase() + ".onlyBlockCreative", false) && event.getPlayer().getGameMode() == GameMode.SURVIVAL)
			return;
		
		if (NoSpawnEggs.getMainConfig().getStringList("blocking.golem." + type.name().toLowerCase() + ".ignoredWorlds") != null)
			if (NoSpawnEggs.getMainConfig().getStringList("blocking.golem." + type.name().toLowerCase() + ".ignoredWorlds").contains(event.getBlock().getWorld().getName()))
				return;
		
		event.setCancelled(true);
		
		event.getPlayer().sendMessage(ChatColor.GOLD + NoSpawnEggs.getLocaleConfig().getString("message.no" + type.proper + "GolemPerms", "You don't have permission to create " + type.proper + " Golems."));
	}
	
	static GolemType placeCreatesGolem(BlockPlaceEvent event)
	{
		Location loc = event.getBlock().getLocation();
		
		if (loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-1, loc.getBlockZ()).getType().equals(Material.SNOW_BLOCK)
				&& loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-2, loc.getBlockZ()).getType().equals(Material.SNOW_BLOCK))
			return GolemType.SNOW;
		
		if ((loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-1, loc.getBlockZ()).getType().equals(Material.IRON_BLOCK)
				&& loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-2, loc.getBlockZ()).getType().equals(Material.IRON_BLOCK)) &&
			((loc.getWorld().getBlockAt(loc.getBlockX()+1, loc.getBlockY()-1, loc.getBlockZ()).getType().equals(Material.IRON_BLOCK) &&
					loc.getWorld().getBlockAt(loc.getBlockX()-1, loc.getBlockY()-1, loc.getBlockZ()).getType().equals(Material.IRON_BLOCK)) ||
					((loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-1, loc.getBlockZ()+1).getType().equals(Material.IRON_BLOCK) &&
							loc.getWorld().getBlockAt(loc.getBlockX(), loc.getBlockY()-1, loc.getBlockZ()-1).getType().equals(Material.IRON_BLOCK)))))
			return GolemType.IRON;
		
		return GolemType.NONE;
	}
	
	enum GolemType
	{
		SNOW("Snow"), IRON("Iron"), NONE("");
		
		GolemType(String name)
		{
			this.proper = name;
		}
		
		String proper = "";
	}
}
